#!/usr/bin/perl
#
################################################################################
#
# Library file for Connection Scheduler AddOn
#
# Copyright (C) 2006-2009 Olaf (weizen_42) Westrik
#
# This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version. 
#
# This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. 
#
# You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA 
#
#
# Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der GNU General Public License, wie von der Free Software Foundation verffentlicht, weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder (nach Ihrer Option) jeder spteren Version. 
#
# Die Verffentlichung dieses Programms erfolgt in der Hoffnung, da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 
#
# Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem Programm erhalten haben. Falls nicht, schreiben Sie an die Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
#
################################################################################
#
# For support post / read in http://www.ipcop-forum.de
#
# $Id: lib.pl 348 2009-03-28 17:09:56Z weizen_42 $
#
# Revision history:
#
# 2006-04-xx created by weizen_42 at ipcop-forum dot de
#
# 2006-05-14  weizen_42       v0.1.0  version changed
# 2006-06-xx  weizen_42       v0.2.0  version changed (reboot / shutdown)
# 2006-08-20  weizen_42       v0.3.0  (ipsecctrl)
# 2006-10-08  weizen_42       v0.4.0  rewrite ppp secrets when changing profile (see SF bug 1557321)
# 2006-10-28  weizen_42               (openvpnctrl)
# 2007-05-07  weizen_42       v0.5.0  WLAN AP
# 


package CONNSCHED;

$CONNSCHED::version = 'v0.6.1';
$CONNSCHED::maxprofiles = 5;

@CONNSCHED::weekdays = ( 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun' );
@CONNSCHED::weekdays_pr = ( 'monday', 'tuesday', 'wednesday', 'thursday', 'friday', 'saturday', 'sunday' );

%CONNSCHED::config;
$CONNSCHED::configfile = "/var/ipcop/connscheduler/connscheduler.conf";
&ReadConfig;

$CONNSCHED::configsize = 0;

1;

#
# load the configuration file
#
sub ReadConfig
{
  # datafileformat:
  # active,action,profilenr,time,daystype,days,weekdays,,comment

  @CONNSCHED::config = ();

  my @tmpfile = ();
  if ( open(FILE, "$configfile") )
  {
    @tmpfile = <FILE>;
    close (FILE);
  }

  foreach $line ( @tmpfile )
  {
    chomp($line);               # remove newline
    my @temp = split(/\,/,$line,9);
    if ( ($temp[0] ne 'on') &&  ($temp[0] ne 'off') ) { next; }

    my $weekdays_pr = '';
    for (my $i = 0; $i < 7; $i++)
    {
      if ( index($temp[6], $CONNSCHED::weekdays[$i]) != -1 )
      {
        $weekdays_pr .= "$Lang::tr{$CONNSCHED::weekdays_pr[$i]} ";
      }
    }

    $CONNSCHED::configsize++;
    push @CONNSCHED::config, { ACTIVE => $temp[0], ACTION => $temp[1], PROFILENR => $temp[2], TIME => $temp[3], 
      DAYSTYPE => $temp[4], DAYS => $temp[5], WEEKDAYS => $temp[6], WEEKDAYS_PR => $weekdays_pr, COMMENT => $temp[8] };
  }
}

#
# write the configuration file
#
sub WriteConfig
{
  open(FILE, ">$configfile") or die 'hosts datafile error';

  for my $i ( 0 .. $#CONNSCHED::config )
  {
    if ( ($CONNSCHED::config[$i]{'ACTIVE'} ne 'on') && ($CONNSCHED::config[$i]{'ACTIVE'} ne 'off') ) { next; }

    print FILE "$CONNSCHED::config[$i]{'ACTIVE'},$CONNSCHED::config[$i]{'ACTION'},$CONNSCHED::config[$i]{'PROFILENR'},";
    print FILE "$CONNSCHED::config[$i]{'TIME'},$CONNSCHED::config[$i]{'DAYSTYPE'},";
    print FILE "$CONNSCHED::config[$i]{'DAYS'},$CONNSCHED::config[$i]{'WEEKDAYS'},,$CONNSCHED::config[$i]{'COMMENT'}\n";
  }
  close FILE;

  &ReadConfig();
}
